/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource["epages.cartridges.de_epages.design.widget.Navbarpreview"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["epages.cartridges.de_epages.design.widget.Navbarpreview"] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

	epages.cartridges.de_epages.design.widget.Navbarpreview $Revision: 1.16 $

*/
dojo.provide("epages.cartridges.de_epages.design.widget.Navbarpreview");
dojo.require("epages.widget.LocalizedWidget");
dojo.require("dijit._Container");

dojo.declare(
	"epages.cartridges.de_epages.design.widget.Navbarpreview",
	[epages.widget.LocalizedWidget,dijit._Contained],
	{
		/**
		 * public properties
		 */
		templateType: 'Layout1',
		defaultTemplateType: 'Layout1',

		_templateMapping:{
			'Layout1' : {templateString:"<div class=\"NavbarPreviewLayout1 ${cssClass}\">\n  <div dojoAttachpoint=\"roofNode\" class=\"NavbarPreviewRoof EnableHover\" style=\"display:none\"></div>\n  <div dojoAttachpoint=\"headerNode\" class=\"NavbarPreviewHeader EnableHover\" style=\"display:none\"></div>\n  <div dojoAttachpoint=\"topNode\" class=\"NavbarPreviewTop EnableHover\" style=\"display:none\"></div>\n  <div class=\"NavbarPreviewThreeColumns\">\n    <div class=\"NavbarPreviewContent\"></div>\n    <div dojoAttachpoint=\"leftNode\" class=\"NavbarPreviewLeft EnableHover\" style=\"display:none\"></div>\n    <div dojoAttachpoint=\"rightNode\" class=\"NavbarPreviewRight EnableHover\" style=\"display:none\"></div>\n  </div>\n  <div dojoAttachpoint=\"bottomNode\" class=\"NavbarPreviewBottom EnableHover\" style=\"display:none\"></div>\n  <div dojoAttachpoint=\"footerNode\" class=\"NavbarPreviewFooter EnableHover\" style=\"display:none\"></div>\n</div>\n"},
			'Layout2' : {templateString:"<div class=\"NavbarPreviewLayout2 ${cssClass}\">\n  <div dojoAttachpoint=\"roofNode\" class=\"NavbarPreviewRoof EnableHover\" style=\"display:none\"></div>\n  <div dojoAttachpoint=\"headerNode\" class=\"NavbarPreviewHeader EnableHover\" style=\"display:none\"></div>\n  <div class=\"NavbarPreviewThreeColumns\">\n    <div class=\"NavbarPreviewContent\"></div>\n    <div dojoAttachpoint=\"topNode\" class=\"NavbarPreviewTop EnableHover\" style=\"display:none\"></div>\n    <div dojoAttachpoint=\"bottomNode\" class=\"NavbarPreviewBottom EnableHover\" style=\"display:none\"></div>\n    <div dojoAttachpoint=\"leftNode\" class=\"NavbarPreviewLeft EnableHover\" style=\"display:none\"></div>\n    <div dojoAttachpoint=\"rightNode\" class=\"NavbarPreviewRight EnableHover\" style=\"display:none\"></div>\n  </div>\n  <div dojoAttachpoint=\"footerNode\" class=\"NavbarPreviewFooter EnableHover\" style=\"display:none\"></div>\n</div>\n"},
			'Layout3' : {templateString:"<div class=\"NavbarPreviewLayout3 ${cssClass}\">\n  <div class=\"NavbarPreviewThreeColumns\">\n    <div class=\"NavbarPreviewContent\"></div>\n    <div class=\"NavbarPreviewHeaderAndTop\">\n  \t\t<div dojoAttachpoint=\"roofNode\" class=\"NavbarPreviewRoof EnableHover\" style=\"display:none\"></div>\n      <div dojoAttachpoint=\"headerNode\" class=\"NavbarPreviewHeader EnableHover\" style=\"display:none\"></div>\n      <div dojoAttachpoint=\"topNode\" class=\"NavbarPreviewTop EnableHover\" style=\"display:none\"></div>\n    </div>\n    <div class=\"NavbarPreviewBottomAndFooter\">\n      <div dojoAttachpoint=\"bottomNode\" class=\"NavbarPreviewBottom EnableHover\" style=\"display:none\"></div>\n      <div dojoAttachpoint=\"footerNode\" class=\"NavbarPreviewFooter EnableHover\" style=\"display:none\"></div>\n    </div>\n    <div dojoAttachpoint=\"leftNode\" class=\"NavbarPreviewLeft EnableHover\" style=\"display:none\"></div>\n    <div dojoAttachpoint=\"rightNode\" class=\"NavbarPreviewRight EnableHover\" style=\"display:none\"></div>\n  </div>\n</div>\n"}
		},
		cssClass : '',
		visibleNavBars: undefined,

		/**
		 * widget properties
		 */
		imagePath       : epages.themeUrl('images'),
		templateString:"<div class=\"NavbarPreviewLayout1 ${cssClass}\">\n  <div dojoAttachpoint=\"roofNode\" class=\"NavbarPreviewRoof EnableHover\" style=\"display:none\"></div>\n  <div dojoAttachpoint=\"headerNode\" class=\"NavbarPreviewHeader EnableHover\" style=\"display:none\"></div>\n  <div dojoAttachpoint=\"topNode\" class=\"NavbarPreviewTop EnableHover\" style=\"display:none\"></div>\n  <div class=\"NavbarPreviewThreeColumns\">\n    <div class=\"NavbarPreviewContent\"></div>\n    <div dojoAttachpoint=\"leftNode\" class=\"NavbarPreviewLeft EnableHover\" style=\"display:none\"></div>\n    <div dojoAttachpoint=\"rightNode\" class=\"NavbarPreviewRight EnableHover\" style=\"display:none\"></div>\n  </div>\n  <div dojoAttachpoint=\"bottomNode\" class=\"NavbarPreviewBottom EnableHover\" style=\"display:none\"></div>\n  <div dojoAttachpoint=\"footerNode\" class=\"NavbarPreviewFooter EnableHover\" style=\"display:none\"></div>\n</div>\n",
		translationName : dojo.moduleUrl('epages.cartridges.de_epages.design.widget','templates/translation'),

		postCreate: function() {
			this.templateDirectory = dojo.moduleUrl('epages.cartridges.de_epages.design.widget','templates');
			this.inherited('postCreate', arguments);
			this.visibleNavBars = epages.NavBars;
			if(this.visibleNavBars) {
				for(var el in this.visibleNavBars) {
					var navString=this.visibleNavBars[el][2];
					if(navString != "Delete") {
						this.enableBar(navString.toLowerCase());
						this.addNavbarEvents(navString, el);
					}
				}
			} else {
				console.warn("epages.NavBars not defined in "+this.declaredClass);
			}
		},

		addNavbarEvents : function(/* string */ navbar, /* string */ epObjectId) {
			var navbarlc = navbar.toLowerCase();
			var navbarNode = this[navbarlc + 'Node']
			navbarNode.ep_objectId = epObjectId;
			navbarNode.ep_navbar = navbar;
			this.connect(navbarNode, "onclick", '_publishSelect');
		},

		_publishSelect: function(evt) {
			var node = evt.currentTarget;
			dojo.stopEvent(evt);
			dojo.publish(this.id+'/select', [{ navbar: node.ep_navbar, objectId: node.ep_objectId }]);
		},

		enableBar: function (navbar) {
			this[navbar + 'Node'].style.display="";
		},

		disableBar: function (navbar) {
			this[navbar + 'Node'].style.display="none";
		},

		switchBar: function (navbar) {
			if (this[navbar + 'Node'].style.display=="none") {
				this.enableBar(navbar);
			} else {
				this.disableBar(navbar);
			}
		}
	}
);

}
