/*
	Copyright (c) 2004-2011, The Dojo Foundation All Rights Reserved.
	Available via Academic Free License >= 2.1 OR the modified BSD license.
	see: http://dojotoolkit.org/license for details
*/


if(!dojo._hasResource['epages.io.html_test']){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource['epages.io.html_test'] = true;
/*
	Copyright (c) 2006-2007, ePages GmbH
	All Rights Reserved.

  epages.io.Html $Revision: 1.4 $

*/
dojo.provide('epages.io.html_test');
dojo.require('epages.io.html');

dojo.extend(epages.io.Html, {
	test: /*Boolean*/ function(/*epages.Test*/eTest) {
		// summary:
		//		test this package
		// example:
		// 	  var package = new epages.io.Html();
		//		boolean = package.test(eTest);
		//		// returns true if all test are successfully
		eTest.setPlanned(2);
		eTest.ok(1, 'loaded');

		this.load('htmlTest.inc', $('testTarget'), true);
		eTest.ok($('testTarget').innerHTML == 'Header loaded successfully.', 'load header');
		$('testTarget').innerHTML = '';

		// closing async test
		return eTest.planned == eTest.correct ? true : false;
	}
});

}
